Index: /branches/HTM-6.2-dev0/source/Lib/TLibEncoder/TEncCu.cpp
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibEncoder/TEncCu.cpp	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibEncoder/TEncCu.cpp	(revision 427)
@@ -721,5 +721,9 @@
 
 #if LGE_ILLUCOMP_B0045
+#if SHARP_ILLUCOMP_PARSE_D0060
+    bICEnabled = false;
+#else
     bICEnabled = rpcBestCU->getICFlag(0);
+#endif
 #endif
 
@@ -787,8 +791,14 @@
           Bool bResPredFlag  = ( uiResPrdId > 0 );
 #if LGE_ILLUCOMP_B0045
+#if SHARP_ILLUCOMP_PARSE_D0060
+          {
+            Bool bICFlag = false;
+            rpcTempCU->setICFlagSubParts(bICFlag, 0, 0, uiDepth);
+#else
           for(UInt uiICId = 0; uiICId < (bICEnabled ? 2 : 1); uiICId++)
           {
             Bool bICFlag = (uiICId ? true : false);
             rpcTempCU->setICFlagSubParts(bICFlag, 0, 0, uiDepth);
+#endif
 #endif
 #endif
@@ -1936,5 +1946,13 @@
   rpcTempCU->setPartSizeSubParts( SIZE_2Nx2N, 0, uhDepth ); // interprets depth relative to LCU level
 #if MERL_VSP_C0152
+#if LGE_VSP_INHERIT_D0092
+  Int iVSPIndexTrue[MRG_MAX_NUM_CANDS_MEM];
+  for (Int i=0; i<MRG_MAX_NUM_CANDS_MEM; i++)
+  {
+     iVSPIndexTrue[i] = 0;
+  }
+#else
   Int iVSPIndexTrue[3] = {-1, -1, -1};
+#endif
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
   Int iVSPDirTrue[3]   = {-1, -1, -1};
@@ -1962,4 +1980,13 @@
     {
       TComYuv* pcPredYuvTemp = NULL;
+#if SHARP_ILLUCOMP_PARSE_D0060
+      if (rpcTempCU->getSlice()->getApplyIC() && rpcTempCU->getSlice()->getIcSkipParseFlag())
+      {
+        if (bICFlag && uiMergeCand == 0) 
+        {
+          continue;
+        }
+      }
+#endif
 #if LOSSLESS_CODING
       UInt iteration;
@@ -1998,6 +2025,20 @@
           rpcTempCU->setMergeIndexSubParts( uiMergeCand, 0, 0, uhDepth ); // interprets depth relative to LCU level
 #if MERL_VSP_C0152
+
+#if MTK_D0156
+          if( !rpcTempCU->getSlice()->getSPS()->getUseVSPCompensation() )
+          {
+              rpcTempCU->setVSPIndexSubParts( 0, 0, 0, uhDepth );
+          }
+          else
+#endif
           {
             Int iVSPIdx = 0;
+#if LGE_VSP_INHERIT_D0092
+            if (iVSPIndexTrue[uiMergeCand] == 1)
+            {
+                iVSPIdx = 1;
+            }
+#else
             Int numVSPIdx;
             numVSPIdx = 3;
@@ -2010,7 +2051,15 @@
                 }
             }
+#endif
             rpcTempCU->setVSPIndexSubParts( iVSPIdx, 0, 0, uhDepth );
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
             rpcTempCU->setVSPDirSubParts( iVSPDirTrue[iVSPIdx-1], 0, 0, uhDepth ); // interprets depth relative to LCU level
+#endif
+#if QC_BVSP_CleanUP_D0191 && !LGE_VSP_INHERIT_D0092
+           if(iVSPIdx != 0)
+           {
+             Int iIVCIdx = rpcTempCU->getSlice()->getRefPic(REF_PIC_LIST_0, 0)->getPOC()==rpcTempCU->getSlice()->getPOC() ? 0: rpcTempCU->getSlice()->getNewRefIdx(REF_PIC_LIST_0);
+             cMvFieldNeighbours[2*uiMergeCand].setRefIdx(iIVCIdx);
+           }
 #endif
           }
Index: /branches/HTM-6.2-dev0/source/Lib/TLibEncoder/TEncEntropy.cpp
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibEncoder/TEncEntropy.cpp	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibEncoder/TEncEntropy.cpp	(revision 427)
@@ -54,4 +54,14 @@
   if (pcSlice->getSPS()->getUseSAO())
   {
+#if LGE_SAO_MIGRATION_D0091
+    if (pcSlice->getSPS()->getUseSAO())
+    {
+        SAOParam *saoParam = pcSlice->getAPS()->getSaoParam();
+        pcSlice->setSaoEnabledFlag     (saoParam->bSaoFlag[0]);
+        {
+            pcSlice->setSaoEnabledFlagChroma   (saoParam->bSaoFlag[1]);
+        }
+    }
+#else
     pcSlice->setSaoInterleavingFlag(pcSlice->getAPS()->getSaoInterleavingFlag());
     pcSlice->setSaoEnabledFlag     (pcSlice->getAPS()->getSaoParam()->bSaoFlag[0]);
@@ -66,4 +76,5 @@
       pcSlice->setSaoEnabledFlagCr   (0);
     }
+#endif
   }
 
@@ -1384,5 +1395,9 @@
   {
 #if H3D_IVMP
+#if SEC_TWO_CANDIDATES_FOR_AMVP_D0122
+    const Int iNumCands = AMVP_MAX_NUM_CANDS;
+#else
     const Int iNumCands = AMVP_MAX_NUM_CANDS + ( pcCU->getSlice()->getSPS()->getMultiviewMvPredMode() ? 1 : 0 );
+#endif
     m_pcEntropyCoderIf->codeMVPIdx( pcCU, uiAbsPartIdx, eRefList, iNumCands );
 #else
@@ -1528,4 +1543,102 @@
 }
 
+#if LGE_SAO_MIGRATION_D0091
+Void TEncEntropy::encodeSaoOffset(SaoLcuParam* saoLcuParam, UInt compIdx)
+{
+    UInt uiSymbol;
+    Int i;
+
+    uiSymbol = saoLcuParam->typeIdx + 1;
+    if (compIdx!=2)
+    {
+        m_pcEntropyCoderIf->codeSaoTypeIdx(uiSymbol);
+    }
+
+    if (uiSymbol)
+    {
+        if (saoLcuParam->typeIdx < 4 && compIdx != 2)
+        {
+            saoLcuParam->subTypeIdx = saoLcuParam->typeIdx;
+        }
+#if FULL_NBIT
+        Int offsetTh = 1 << ( min((Int)(g_uiBitDepth + (g_uiBitDepth-8)-5),5) );
+#else
+        Int offsetTh = 1 << ( min((Int)(g_uiBitDepth + g_uiBitIncrement-5),5) );
+#endif
+        if( saoLcuParam->typeIdx == SAO_BO )
+        {
+            for( i=0; i< saoLcuParam->length; i++)
+            {
+                UInt absOffset = ( (saoLcuParam->offset[i] < 0) ? -saoLcuParam->offset[i] : saoLcuParam->offset[i]);
+                m_pcEntropyCoderIf->codeSaoMaxUvlc(absOffset, offsetTh-1);
+            }  
+            for( i=0; i< saoLcuParam->length; i++)
+            {
+                if (saoLcuParam->offset[i] != 0)
+                {
+                    UInt sign = (saoLcuParam->offset[i] < 0) ? 1 : 0 ;
+                    m_pcEntropyCoderIf->codeSAOSign(sign);
+                }
+            }
+            uiSymbol = (UInt) (saoLcuParam->subTypeIdx);
+            m_pcEntropyCoderIf->codeSaoUflc(5, uiSymbol);
+        }
+        else if( saoLcuParam->typeIdx < 4 )
+        {
+            m_pcEntropyCoderIf->codeSaoMaxUvlc( saoLcuParam->offset[0], offsetTh-1);
+            m_pcEntropyCoderIf->codeSaoMaxUvlc( saoLcuParam->offset[1], offsetTh-1);
+            m_pcEntropyCoderIf->codeSaoMaxUvlc(-saoLcuParam->offset[2], offsetTh-1);
+            m_pcEntropyCoderIf->codeSaoMaxUvlc(-saoLcuParam->offset[3], offsetTh-1);
+
+            if (compIdx!=2)
+            {
+                uiSymbol = (UInt) (saoLcuParam->subTypeIdx);
+                m_pcEntropyCoderIf->codeSaoUflc(2, uiSymbol);
+            }
+        }
+    }
+}
+
+/** Encode SAO unit interleaving
+* \param  rx
+* \param  ry
+* \param  pSaoParam
+* \param  pcCU
+* \param  iCUAddrInSlice
+* \param  iCUAddrUpInSlice
+* \param  bLFCrossSliceBoundaryFlag
+ */
+Void TEncEntropy::encodeSaoUnitInterleaving(Int compIdx, Bool saoFlag, Int rx, Int ry, SaoLcuParam* saoLcuParam, Int cuAddrInSlice, Int cuAddrUpInSlice, Int allowMergeLeft, Int allowMergeUp)
+{
+    if (saoFlag)
+    {
+        if (rx>0 && cuAddrInSlice!=0 && allowMergeLeft)
+        {
+            m_pcEntropyCoderIf->codeSaoMerge(saoLcuParam->mergeLeftFlag);
+        }
+        else
+        {
+            saoLcuParam->mergeLeftFlag = 0;
+        }
+        
+        if (saoLcuParam->mergeLeftFlag == 0)
+        {
+            if ( (ry > 0) && (cuAddrUpInSlice>=0) && allowMergeUp )
+            {
+                m_pcEntropyCoderIf->codeSaoMerge(saoLcuParam->mergeUpFlag);
+            }
+            else
+            {
+                saoLcuParam->mergeUpFlag = 0;
+            }
+
+            if (!saoLcuParam->mergeUpFlag)
+            {
+                encodeSaoOffset(saoLcuParam, compIdx);
+            }
+        }
+    }
+}
+#else
 /** Encode SAO Offset
  * \param  saoLcuParam SAO LCU paramters
@@ -1715,4 +1828,5 @@
   }
 }
+#endif
 
 Int TEncEntropy::countNonZeroCoeffs( TCoeff* pcCoef, UInt uiSize )
Index: /branches/HTM-6.2-dev0/source/Lib/TLibEncoder/TEncEntropy.h
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibEncoder/TEncEntropy.h	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibEncoder/TEncEntropy.h	(revision 427)
@@ -157,4 +157,11 @@
 
   virtual Void codeAlfCtrlFlag      ( UInt uiSymbol ) = 0;
+#if LGE_SAO_MIGRATION_D0091
+  virtual Void codeSAOSign          ( UInt code   ) = 0;
+  virtual Void codeSaoMaxUvlc       ( UInt code, UInt maxSymbol ) = 0;
+  virtual Void codeSaoMerge         ( UInt   uiCode  ) = 0;
+  virtual Void codeSaoTypeIdx       ( UInt   uiCode) = 0;
+  virtual Void codeSaoUflc          ( UInt uiLength, UInt   uiCode ) = 0;
+#else
   virtual Void codeSaoFlag          ( UInt uiCode ) = 0;
   virtual Void codeSaoUvlc          ( UInt uiCode ) = 0;
@@ -165,4 +172,5 @@
   virtual Void codeSaoTypeIdx      ( UInt   uiCode) = 0;
   virtual Void codeSaoUflc         ( UInt   uiCode) = 0;
+#endif
   virtual Void estBit               (estBitsSbacStruct* pcEstBitsSbac, Int width, Int height, TextType eTType) = 0;
   
@@ -316,8 +324,13 @@
   Int golombEncode(int coeff, int k);
   Int lengthGolomb(int coeffVal, int k);
+#if LGE_SAO_MIGRATION_D0091
+  Void    encodeSaoOffset(SaoLcuParam* saoLcuParam, UInt compIdx);
+  Void    encodeSaoUnitInterleaving(Int compIdx, Bool saoFlag, Int rx, Int ry, SaoLcuParam* saoLcuParam, Int cuAddrInSlice, Int cuAddrUpInSlice, Int allowMergeLeft, Int allowMergeUp);
+#else
   Void    encodeSaoUnit(Int rx, Int ry, Int compIdx, SAOParam* saoParam, Int repeatedRow);
   Void    encodeSaoOffset(SaoLcuParam* saoLcuParam);
   Void    encodeSaoUnitInterleaving(Int rx, Int ry, SAOParam* saoParam, TComDataCU* cu, Int cuAddrInSlice, Int cuAddrUpInSlice, Bool lfCrossSliceBoundaryFlag);
   Void    encodeSaoParam         (TComAPS*  aps);
+#endif
 
   static Int countNonZeroCoeffs( TCoeff* pcCoef, UInt uiSize );
Index: /branches/HTM-6.2-dev0/source/Lib/TLibEncoder/TEncGOP.cpp
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 427)
@@ -1264,5 +1264,7 @@
             TComAPS cAPS;
             allocAPS(&cAPS, pcSlice->getSPS());
+#if !LGE_SAO_MIGRATION_D0091
             cAPS.setSaoInterleavingFlag(m_pcCfg->getSaoInterleavingFlag());
+#endif
             // set entropy coder for RD
             m_pcEntropyCoder->setEntropyCoder ( m_pcCavlcCoder, pcSlice );
@@ -1272,9 +1274,21 @@
               m_pcEntropyCoder->resetEntropy();
               m_pcEntropyCoder->setBitstream( m_pcBitCounter );
+#if LGE_SAO_MIGRATION_D0091
+              m_pcSAO->startSaoEnc(pcPic, m_pcEntropyCoder, m_pcEncTop->getRDSbacCoder(), m_pcEncTop->getRDGoOnSbacCoder());
+#else
               m_pcSAO->startSaoEnc(pcPic, m_pcEntropyCoder, m_pcEncTop->getRDSbacCoder(), NULL);
+#endif
               SAOParam& cSaoParam = *(cAPS.getSaoParam());
 
 #if SAO_CHROMA_LAMBDA 
+#if LGE_SAO_MIGRATION_D0091
+#if SAO_ENCODING_CHOICE
+              m_pcSAO->SAOProcess(&cSaoParam, pcPic->getSlice(0)->getLambdaLuma(), pcPic->getSlice(0)->getLambdaChroma(), pcPic->getSlice(0)->getDepth());
+#else
               m_pcSAO->SAOProcess(&cSaoParam, pcPic->getSlice(0)->getLambdaLuma(), pcPic->getSlice(0)->getLambdaChroma());
+#endif
+#else
+              m_pcSAO->SAOProcess(&cSaoParam, pcPic->getSlice(0)->getLambdaLuma(), pcPic->getSlice(0)->getLambdaChroma());
+#endif
 #else
 #if ALF_CHROMA_LAMBDA
@@ -1561,5 +1575,7 @@
     m_pcEntropyCoder->encodeDFParams(pcAPS);
   }
+#if !LGE_SAO_MIGRATION_D0091
   m_pcEntropyCoder->encodeSaoParam(pcAPS);
+#endif
   m_pcEntropyCoder->encodeAPSAlfFlag( pcAPS->getAlfEnabled()?1:0);
   if(pcAPS->getAlfEnabled())
